<template>
	<div :class="[$style.statisticsV3Mobile, { [$style.hasLessThan2Slides]: items.length < 2 }]">
		<h2 v-if="moduleTitle" :class="$style.title">
			{{ moduleTitle }}
		</h2>
		<MoleculeCarousel
			ref="carousel"
			:autoplay="shouldAutoadvance"
			:autoplay-delay="autoadvanceIntervalDelay"
			:has-navigation="false"
		>
			<MoleculeCarouselSlide
				v-for="({ navTitle, heading, content, testingDetails, footnote, imageMobile }, i) in items"
				:key="i"
				v-slot="{ isSlideActive }"
				:slide-index="i"
			>
				<div :class="sharedStyle.statisticsImage">
					<BaseImage
						role="presentation"
						aria-hidden="true"
						:image="imageMobile"
						:images="{ large: null }"
						sizes="100vw"
						compression-level="low"
						alt=""
					/>
				</div>

				<div>
					<span :class="sharedStyle.separator" />
					<h3 :class="$style.navTitle">{{ navTitle }}</h3>
					<h4 :class="sharedStyle.heading"
						>{{ heading
						}}<component
							:is="isSlideActive ? 'button' : 'span'"
							v-if="$hasRichText(footnote)"
							:aria-label="$hasRichText(footnote) ? 'Skip to footnote' : null"
							@click="() => focusOnFootnote($hasRichText(footnote), i)"
							@keydown.space.enter="() => focusOnFootnote($hasRichText(footnote), i)"
							>*</component
						>
					</h4>
					<div v-rich-content :class="sharedStyle.information" v-html="content" />
					<div
						v-if="$hasRichText(testingDetails)"
						v-rich-content
						:class="[sharedStyle.detailsAndFootnote, sharedStyle.details]"
						v-html="testingDetails"
					/>
					<div
						v-if="$hasRichText(footnote)"
						ref="footnote"
						v-rich-content
						tabindex="-1"
						:class="[sharedStyle.detailsAndFootnote, sharedStyle.footnote]"
						v-html="footnote"
					/>
				</div>
			</MoleculeCarouselSlide>
		</MoleculeCarousel>
	</div>
</template>

<script>
import MoleculeCarousel from '@components/molecule-carousel';
import MoleculeCarouselSlide from '@components/molecule-carousel-slide';
import { mapState } from 'vuex';

export default {
	components: {
		MoleculeCarousel,
		MoleculeCarouselSlide,
	},

	props: {
		moduleTitle: {
			type: String,
			default: '',
		},

		items: {
			type: Array,
			required: true,
		},

		sharedStyle: {
			type: Object,
			required: true,
		},

		autoadvance: {
			type: Boolean,
			required: true,
		},

		autoadvanceIntervalDelay: {
			type: Number,
			required: true,
		},
	},

	computed: {
		...mapState('screen', ['large']),

		shouldAutoadvance() {
			return this.autoadvance && !this.large;
		},
	},

	methods: {
		focusOnFootnote(hasFootnote, index) {
			if (hasFootnote) {
				const footnote = Array.isArray(this.$refs.footnote) && this.$refs.footnote[index];
				if (footnote) footnote.focus();
			}
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.statisticsV3Mobile {
	padding: 4.8rem 0 3rem;

	@include above('large') {
		display: none;
	}
}

.title {
	@include use-text-style('heading-200');

	padding: 0 3.3rem 0.8em;
	font-family: font-family('secondary');
	line-height: 1.52;
	text-align: center;
}

.navTitle {
	@include use-text-style('type-100');

	margin: 0 0 2.7rem;
	text-align: center;
}

.hasLessThan2Slides [class^='carousel'] + [class^='wrapper'] {
	display: none;
}
</style>
